
class BaseExit(SystemExit):
	pass

class ServerError(BaseExit):
	"""
	Ошибки инфраструктуры
	"""

class BrowserError(BaseExit):
	"""
	Не удалось создать объект браузера
	"""

class BrowserVersionError(BrowserError):
	"""
	Не верно указана версия браузера
	"""

class AuthError(BrowserError):
	"""
	Ошибка авторизации
	"""

class PathError(BaseExit):
	"""
	Ошибка пути к файлу
	"""

class TestConfigError(BaseExit):
	"""
	Ошибки тестовой конфигурации
	"""

class InstallError(BaseExit):
	"""
	Ошибка установки драйвера или браузера
	"""

class InstallExistsError(InstallError):
	"""
	Устанавливаемый файл отсутствует
	"""

class EngineError(BaseExit):
	"""
	Ошибка интерпретатора
	"""

class ParameterError(BaseExit):
	"""
	Не верный параметр
	"""

##################################################################

class TestError(Exception):
	"""
	Базовый класс ошибок
	"""

class FatalError(TestError):
	"""
	Ошибка завершающая теста
	"""

class VarError(FatalError):
	"""
	Переменная не определена
	"""

class Status500(FatalError):
	"""
	Ошибка сервера
	"""

class Status400(FatalError):
	"""
	Страница не найдена
	"""

class LicenseError(FatalError):
	"""
	Нарушение лицензии
	"""

##################################################################

class Failed(TestError):
	"""
	Не фатальная ошибка
	"""

class ActionError(TestError):
	"""
	Ошибка выполнения действия
	"""

class SelectorError(Failed):
	"""
	Ошибки поиска элемента
	"""

class NothingError(Failed):
	"""
	Пропуск действия
	"""

class TriggerNothing(NotImplementedError):
	"""
	Ошибки триггера
	"""
