from typing import Callable, TypeVar

E = TypeVar("E")

class TEST_STATUS:
	UNKNOWN: str
	STARTED: str
	PASSED: str
	RETRO_PASSED: str
	WARNING: str
	FAILED: str
	FATAL: str
	TIMEOUT: str
	ERROR: str
	XFAILED: str
	XPASSED: str
	SKIPPED: str
	STOPPED: str

class COMMAND_STATUS:
	PASSED: str
	SKIPPED: str
	WARNING: str
	FAILED: str
	FATAL: str
	TIMEOUT: str
	ERROR: str
	SKIP_TEST: str
	STOPPED: str

class RETRIES_MODE:
	OFF: str
	ALL: str
	FLAKY: str
	CRITICAL: str
	BLOCKER: str

class SEVERITY:
	TRIVIAL: str
	MINOR: str
	NORMAL: str
	CRITICAL: str
	BLOCKER: str

class LOAD_STRATEGY:
	NORMAL: str
	EAGER: str
	NONE: str

class LOG_LEVEL:
	OFF: str
	SEVERE: str
	WARNING: str
	INFO: str
	DEBUG: str
	ALL: str

class LOG_TYPES:
	BROWSER: str
	CLIENT: str
	DRIVER: str
	PERFORMANCE: str
	PROFILER: str
	SERVER: str

class AUTH_METHOD:
	OFF: str
	BASE: str
	DIGEST: str

class ItemConfig:
	@classmethod
	def registrator(cls, *obj: ItemConfig):
		"""
		Регистрирует новое описание параметра конфигурации
		"""
	
	@classmethod
	def registr_data(cls) -> dict:
		"""
		Возвращает словарь описаний параметров конфигурации
		"""
	
	def __init__(self, name: str, data_type: E, default: E, description: str, serialize: Callable, desirialize: Callable, validator: Callable, read_only: bool, public: bool, key: str, full_key: str, help: str):
		pass
	
	@property
	def argument(self) -> (list, dict):
		"""
		Возвращает кортеж аргументов для ArgumentParser
		"""
	
	@property
	def help(self) -> str:
		"""
		Справочная информация
		"""
	
	@property
	def key(self) -> str:
		"""
		Возвращает сокращённый ключ для установки опции из командной строки
		"""
	
	@property
	def full_key(self) -> str:
		"""
		Возвращает сокращённый ключ для установки опции из командной строки
		"""
	
	@property
	def name(self) -> str:
		"""
		Наименование параметра конфигурации
		"""
	
	@property
	def description(self) -> str:
		"""
		Описание параметра когфигурации
		"""
	
	@property
	def data_type(self) -> E:
		"""
		Тип данны хпараметра конфигурации
		"""
	
	@property
	def default(self) -> E:
		"""
		Значение по умолчанию для парметра конфигурации
		"""
	
	@property
	def serialize(self) -> Callable:
		"""
		Сериализатор - унарная функция возвращающее сериализованное значение параметра
		"""
	
	@property
	def desirialize(self) -> Callable:
		"""
		Десерализатор - унарная функция востанавливающая заначения параметра из сериализвованного
		"""
	
	@property
	def validator(self) -> Callable:
		"""
		Валидатор - унарный предикат. True если знеачение параметра валидно, онче False
		"""
	
	@property
	def read_only(self) -> bool:
		"""
		Нельзя менять значение параметра
		"""
	
	@property
	def public(self) -> bool:
		"""
		Отображать значение в словаре конфигурации
		"""

class CONFIG:
	VERSION: str
	BUILD_DATE: str
	WIDTH_CONSOLE: int
	ONLY_INFO: bool
	TEST_CONFIG_PATH: str
	TEST_CONFIG_NAME: str
	TEST_CONFIG_DIR: str
	EXT_DIR_PATH: str
	BROWSERS_DIR: str
	DOWNLOAD_DIR: str
	CACHE_DIR: str
	REPORT_DIR: str
	USER_PROFILE: bool
	REMOTE_EXECUTOR: str
	REMOTE_TIMEOUT: float
	LOG_LEVEL: LOG_LEVEL
	BASE_URL: str
	TAGS: frozenset
	TEST_ID: frozenset
	THREADS: int
	DELAY_THREADS: float
	SINGLE_THREADS: bool
	PAGE_SIZE:  (int, int)
	REPORTS: tuple[str]
	BROWSERS: frozenset
	VACUUM: bool
	HEADLESS: bool
	INCOGNITO: bool
	TEST_FATALITY: bool
	TEST_REPEATED: int
	RETRIES_MODE: RETRIES_MODE
	RETRIES: int
	RETRIES_SLEEP: float
	PAGE_LOAD_STRATEGY: LOAD_STRATEGY
	TEST_TIMEOUT: float
	PAGE_LOAD_TIMEOUT: float
	SCRIPT_TIMEOUT: float
	WAIT_TIMEOUT: float
	WAIT_FREQUENCY: float
	DEBUG: bool
	SILENTLY: bool
	LICENSE_KEYS: dict
	AUTH_METHOD: AUTH_METHOD
	AUTH_URL: str
	AUTH_USER: str
	AUTH_PASSWD: str
	PROXY: str
	TRIGGER: str
	START_BASE_URL: bool
