# Meta Test 
## Платформа QA тестирования
[https://meta_test.kybyc.xyz/](https://meta_test.kybyc.xyz/)

Платформа предназначена для создания и запуска UI-тестов для автоматизированной проверки веб-приложений людьми без навыков программирования. Для описания тестов используется специальный декларативный "метаязык", что позволяет избавится от сложных для понимания концепций по подобии Page Object Model. Но тем не менее метаязык можно использовать вместе с обычным кодом на языке python что например позволяет более гибко работать с источниками тестовых данных, отправлять API запросы и даже создавать новые команды для метаязыка.
**[Примеры тестовых конфигураций](https://gitflic.ru/project/meta-test/examples)**

В настоящее время платформа представляет из себя:
* метаязык для описания тестовых сценариев со средой выполнения
* систему многопоточного запуска тестов
* встроенные автоматические ожидания
* механизм автоматической загрузки драйверов и браузеров
* систему триггеров
* средства интеграции с инструментами построения отчётов
* систему расширений


## Дистрибутив

Платформа не требует отдельной установки и может использоваться стразу после распаковки дистрибутивного архива. Для её запуска нужно из командной строки перейти в каталог платформы и выполнить исполняемый файл **metatest** (или **metatest.bat** в случае с windows) передав ему имя (если конфигурация находится в каталоге **tests**) или путь к каталогу с конфигурацией тестов. *Подробное описание параметров запуска находится в разделе документации [Параметры среды](https://metatest.kybyc.xyz/doc-config)*

```bash
# Переходим в каталог с платформой и запускаем:
./metatest тестовая_конфигурация [параметры]
```

В некоторых случаях наиболее актуальна глобальная установка платформы. Для неё достаточно распаковать каталог дистрибутива в любое подходящее мести и создать символьную ссылка на исполняемый файл:

Пример глобальной установки:
```bash
# tar -xf meta_test-1.0rc-linux-x86_64-debian_11.tar.gz -C /opt
# ln -s /opt/meta_test/metatest /usr/local/bin/metatest
```

Для установки python - библиотек нужно использовать **pip3** из подкаталога **python/bin/** находящегося в каталоге платформы.

Пример:
```
./python/bin/pip3 install faker
```

## Состав дистрибутива

| Каталог      | Описание                                          |
|--------------|---------------------------------------------------|
| metatest     | Исполняемый файл для запуска платформы            |
| tests/       | Каталог для тестовых конфигураций                 |
| reports/     | Каталог для хранения отчётов                      |
| python/      | Локальное python-окружение                        |
| meta_test/   | Платформа                                         |
| extensions/  | Каталог расширений                                |
| browsers/    | каталог браузеров                                 |

В дистрибутиве поставляются следующие расширения:

| Каталог                     | Описание                                 |
|-----------------------------|------------------------------------------|
| extensions/chrome.py        | Поддержка браузера Google Chrome         |
| extensions/chromium.py      | Поддержка браузера Chromium              |
| extensions/firefox.py       | Поддержка браузера Mozilla Firefox       |
| extensions/edge.py          | Поддержка браузера Microsoft Edge        |
| extensions/safari.py        | Поддержка браузера Safari                |
| extensions/free_keys.py     | Лицензионные ключи для тестовых сайтов   |
| extensions/report_allure.py | Поддержка инструмента отчётов Allure     |
| extensions/selenoid.py      | Поддержка инфраструктуры Selenoid        |

